from rest_framework import generics,status,views,filters
from rest_framework.response import Response
from reportlab.lib.styles import ParagraphStyle
from reportlab.lib.enums import TA_LEFT
from .serializers import PdfRecordSerializer,TestBookingModelSerializer,AppAPIsOPDBookingModelListSerializer,DoctorBookingModelSerializer,AppAPIsOPDSBookModelListSerializer,AppAPIsTestSlotModelsListSerializer,AppAPIsOPDBookModelDataListSerializer,AppAPIsDoctorBookModelSaveListSerializer,AppAPIsOPDBookModelListSerializer,AppAPIsSlotModelListSerializer,AppAPIsTestBooknewModelListSerializer,AppAPIsOPDSlotModelListSerializer,AppAPIsOrderModelCreateSerializer,AppAPIsOrderModelListSerializer,AppAPIsOrganisationSlotBookingModelOrderTestListSerializer,AppAPIsOrganisationSlotBookingModelCreateSerializer,AppAPIsOrganisationSlotBookingModelPUTSerializer,AppAPIsOrganisationSlotBookingModelOrderAppointmentListSerializer,AppAPIsTestBookModelListSerializer,AppAPIsDoctorBookModelListSerializer
from ..models import SlotModel,OPDBookingModel,TestSlotModel,OPDSlotAvailableModel,OrganisationSlotBookingModel,OrderModel,TestBookingModel,DoctorBookingModel
from organisation.models import OrganisationDoctorModel,OPDDepartments
from reviews.models import ReviewModel
from reportlab.pdfgen import canvas
from django.http import HttpResponse
from django_filters.rest_framework import DjangoFilterBackend
from userprofile.models import UserCartModel
from ..utils import generate_order_id,generate_slot_id
from django.contrib.auth import get_user_model
from django.utils import timezone
from datetime import datetime
from core import permissions
import os
from django.conf import settings
from reportlab.platypus import SimpleDocTemplate, Table, TableStyle, Frame, Paragraph, Spacer, PageTemplate
from reportlab.lib.pagesizes import letter
from reportlab.lib.styles import getSampleStyleSheet
from reportlab.lib import colors
from xhtml2pdf import pisa
import uuid
import io
from django.template.loader import render_to_string

class AppAPIsDoctorSlotListAPIView(generics.ListAPIView):
    serializer_class = AppAPIsSlotModelListSerializer
    
    def get_queryset(self):
        
        # Retrieve doctor_id from the request parameters
        doctor_id = self.request.query_params.get('doctor_id')
        date = self.request.query_params.get('date')
        print(date)
        if(date):
            
            return SlotModel.objects.filter(date = date,doctor_id=doctor_id)
        else:
            return SlotModel.objects.filter(doctor_id=doctor_id)
        # Assuming you want to filter by a specific doctor_id
        return DoctorSlotAvailableModel.objects.filter(doctor_id=doctor_id)

    def list(self, request, *args, **kwargs):
        serializer = self.serializer_class(self.get_queryset(), many=True)
        return Response({'slots':serializer.data}, status=status.HTTP_200_OK)


class AppAPIsOPDDeptGetListAPIView(generics.ListAPIView):
    serializer_class = AppAPIsSlotModelListSerializer
    
    
    def get_queryset(self):
        
        # Retrieve doctor_id from the request parameters
        doctor_id = self.request.query_params.get('doctor_id')
        date = self.request.query_params.get('date')
        print(date)
        if(date):
            
            return SlotModel.objects.filter(date = date,doctor_id=doctor_id)
        else:
            return SlotModel.objects.filter(doctor_id=doctor_id)
        # Assuming you want to filter by a specific doctor_id
        return DoctorSlotAvailableModel.objects.filter(doctor_id=doctor_id)

    def list(self, request, *args, **kwargs):
        serializer = self.serializer_class(self.get_queryset(), many=True)
        return Response({'slots':serializer.data}, status=status.HTTP_200_OK)
    



#OPD Slot
class AppAPIsOPDModelListAPIView(generics.ListAPIView):
    serializer_class = AppAPIsOPDSlotModelListSerializer
    
    def get_queryset(self):
      
        # Retrieve doctor_id from the request parameters
        opd = self.request.query_params.get('opd_id')
        date = self.request.query_params.get('date')
        print(date)
        if(date):
            
            return OPDSlotAvailableModel.objects.filter(slot__date = date,opd_id=opd)
        else:
            return OPDSlotAvailableModel.objects.filter(opd_id=opd)
        # Assuming you want to filter by a specific test_id
        return TestSlotAvailableModel.objects.filter(test_id=test_id)

    def list(self, request, *args, **kwargs):
        serializer = self.serializer_class(self.get_queryset(), many=True)
        return Response({'slots':serializer.data}, status=status.HTTP_200_OK)
    
class AppAPIsReciptListAPIView(generics.ListAPIView,generics.GenericAPIView):
   
        
    
    def list(self, request, *args, **kwargs):
        user_id = self.request.user.id
        doctor = DoctorBookingModel.objects.filter(user_id=user_id)
        doctor_serializer = DoctorBookingModelSerializer(doctor, many=True)  
        opd = OPDBookingModel.objects.filter(user_id=user_id)
        opd_serializer = AppAPIsOPDBookingModelListSerializer(opd, many=True)  
        test = TestBookingModel.objects.filter(user_id=user_id)
        test_serializer = TestBookingModelSerializer(test, many=True)

        e = []
        for i in doctor_serializer.data:
          
                a = {
                    "type" : "doctor",
                    "pdf": i['pdf'],
                    "date": i['created_at'],
                    }   ,
                
                e.append(a[0])

        for i in opd_serializer.data:
          
                a = {
                    "type" : "opd",
                    "pdf": i['pdf'],
                    "date": i['created_at'],
                    }   ,
                
                e.append(a[0])

        for i in test_serializer.data:
               
                a = {
                    "type" : "test",
                    "pdf": i['pdf'],
                    "date": i['created_at'],
                    }   ,
                
                e.append(a[0])
        return Response({'data' : e})
         

class AppAPIsTestModelListAPIView(generics.ListAPIView):
    serializer_class = AppAPIsTestSlotModelsListSerializer
    
    def get_queryset(self):
        
        # Retrieve doctor_id from the request parameters
        test_id = self.request.query_params.get('test_id')
        date = self.request.query_params.get('date')
        print(date)
        if(date):
            
            return TestSlotModel.objects.filter(date = date,test_id=test_id)
        else:
            return TestSlotModel.objects.filter(test_id=test_id)
        # Assuming you want to filter by a specific doctor_id
        return DoctorSlotAvailableModel.objects.filter(doctor_id=doctor_id)

    def list(self, request, *args, **kwargs):
        serializer = self.serializer_class(self.get_queryset(), many=True)
        return Response({'slots':serializer.data}, status=status.HTTP_200_OK)
    

class AppAPIsTestBookingsModelListAPIView(generics.ListAPIView):
    
    def get_serializer_class(self):
        return AppAPIsTestBookModelListSerializer

    def get_serializer_context(self):
        context = super().get_serializer_context()
        context['request'] = self.request
        return context

    def get_queryset(self):
        authenticated_user = self.request.user
        print(authenticated_user.id)
        booking_type = self.request.GET.get('booking_type')  # Adjust this based on your actual request parameter

        if booking_type == 'bookings':
            opd_bookings = OPDBookingModel.objects.filter(user=authenticated_user,is_booked=True,opd_status_id=1)
            doctor_bookings = DoctorBookingModel.objects.filter(user=authenticated_user,is_booked=True,is_completed=3)
           
            test_bookings = TestBookingModel.objects.filter(user=authenticated_user,is_booked=True,is_completed=3)
        elif booking_type == 'completed':
            opd_bookings = OPDBookingModel.objects.filter(user=authenticated_user,is_booked=True,opd_status_id=3)
            doctor_bookings = DoctorBookingModel.objects.filter(user=authenticated_user, is_completed=1)
            test_bookings = TestBookingModel.objects.filter(user=authenticated_user, is_completed=1)
         
            
        else:
            # Handle the case when booking_type is neither 'bookings' nor 'completed'
            # doctor_bookings = []
            test_bookings = 'guddu'

        return {'test_bookings': test_bookings,'doctor_bookings': doctor_bookings ,'opd_bookings':opd_bookings}

    def list(self, request, *args, **kwargs):
        queryset_dict = self.get_queryset()

        # if booking_type == 'bookings'
        doctor_serializer = AppAPIsDoctorBookModelListSerializer(queryset_dict['doctor_bookings'], many=True, context=self.get_serializer_context())
        test_serializer = AppAPIsTestBookModelListSerializer(queryset_dict['test_bookings'], many=True, context=self.get_serializer_context())
        opd_serializer = AppAPIsOPDBookModelListSerializer(queryset_dict['opd_bookings'], many=True, context=self.get_serializer_context())
        
        # Add 'type' field to differentiate between doctor and test bookings
        doctor_data = [{'type': 'doctor', **item} for item in doctor_serializer.data]
        test_data = [{'type': 'test', **item} for item in test_serializer.data]
        opd_data =  [{'type': 'opd', **item} for item in opd_serializer.data]

        e = []
        for i in test_data:
            #   return Response( i['type'], status=status.HTTP_200_OK)
            #   print(i,'guddu')
                a = {"booking_type": "test"
                     ,"id": i['id']
                        ,"created_at": i['created_at']
                        ,"title":  i['patient_name']
                        ,"patient_name": i['patient_name']
                        ,"mobile_number":i['mobile_number']
                        ,"rating": i['rating']
                        ,"testId": i['test']['id']
                        ,"orgId": i['hospital_name']['id']
                        ,"token":  ""
                        ,"hospital_name": i['hospital_name']['title'],
                    }   ,
                
                e.append(a[0])
        for m in doctor_data:
            #   return Response( i['type'], status=status.HTTP_200_OK)
            #   print(i,'guddu')
                a = {"booking_type": "doctor"
                     ,"id": m['id']
                        ,"created_at": m['created_at']
                        ,"title":  m['patient_name']
                        ,"patient_name": m['patient_name']
                        ,"mobile_number":m['mobile_number']
                        ,"rating": m['rating']
                        ,"testId":m['doctor']['id']
                        ,"orgId": m['hospital_name']['id']
                         ,"token":  ""
                        ,"hospital_name": m['hospital_name']['title'],
                    }   ,
                
                e.append(a[0])
        for j in opd_data:
            #   return Response( i['type'], status=status.HTTP_200_OK)
            #   print(i,'guddu')
                a = {"booking_type": "opd"
                     ,"id": j['id']
                        ,"created_at": j['created_at']
                        ,"title":  j['patient_name']
                        ,"patient_name": j['patient_name']
                        ,"mobile_number":j['mobile_number']
                        ,"rating": j['rating']
                        ,"testId":j['opd_dept']['id']
                        ,"orgId": j['hospital_name']['id']
                        ,"token":  j['token']
                        ,"hospital_name": j['hospital_name']['title'],
                    }   ,
                
                e.append(a[0])

        return Response({"data":e}, status=status.HTTP_200_OK)
    
class AppAPIsDoctorBookingsModelListAPIView(generics.ListAPIView):
    serializer_class = AppAPIsDoctorBookModelListSerializer
    
    def get_queryset(self):
        authenticated_user = self.request.user
        return DoctorBookingModel.objects.filter(user=authenticated_user)

    def list(self, request, *args, **kwargs):
        serializer = self.serializer_class(self.get_queryset(), many=True)
        return Response(serializer.data, status=status.HTTP_200_OK)
    
class AppAPIsCompletedBookingsModelListAPIView(generics.ListAPIView):
    def get_queryset(self):
        authenticated_user = self.request.user
        print(authenticated_user)
        doctor_bookings = DoctorBookingModel.objects.filter(user=authenticated_user,is_completed = True)
        test_bookings = TestBookingModel.objects.filter(user=authenticated_user,is_completed = True)
        return {'doctor_bookings': doctor_bookings, 'test_bookings': test_bookings}

    def list(self, request, *args, **kwargs):
        queryset_dict = self.get_queryset()
        doctor_serializer = AppAPIsDoctorBookModelListSerializer(queryset_dict['doctor_bookings'], many=True)
        test_serializer = AppAPIsTestBookModelListSerializer(queryset_dict['test_bookings'], many=True)

        # Add 'type' field to differentiate between doctor and test bookings
        doctor_data = [{'type': 'doctor', **item} for item in doctor_serializer.data]
        test_data = [{'type': 'test', **item} for item in test_serializer.data]

        data = {
            'bookings': doctor_data + test_data,
        }

        return Response(data, status=status.HTTP_200_OK)
    
class AppAPIsDoctorBookingsModelStatusCreateAPIView(generics.GenericAPIView):
    serializer_class = AppAPIsDoctorBookModelListSerializer

    def get_queryset(self):
        authenticated_user = self.request.user
        return DoctorBookingModel.objects.filter(user=authenticated_user)

    def get(self, request, *args, **kwargs):
        serializer = self.serializer_class(self.get_queryset(), many=True)
        return Response(serializer.data, status=status.HTTP_200_OK)

    def post(self, request, *args, **kwargs):
        authenticated_user = request.user

        # Assuming you want to update the is_booked status for a specific booking_id
        booking_id = request.data.get('booking_id')  # Adjust the field name based on your actual model

        try:
            booking_instance = DoctorBookingModel.objects.get(id=booking_id, user=authenticated_user)
            booking_instance.is_booked = False  # Set is_booked to zero (False)
            booking_instance.save()

            serializer = self.serializer_class(booking_instance)
            return Response(serializer.data, status=status.HTTP_200_OK)

        except DoctorBookingModel.DoesNotExist:
            return Response({"message": "Booking not found"}, status=status.HTTP_404_NOT_FOUND)

        except Exception as e:
            return Response({"message": f"Something went wrong: {e}"}, status=status.HTTP_500_INTERNAL_SERVER_ERROR)
        
class AppAPIsTestBookingsModelStatusCreateAPIView(generics.GenericAPIView):
    
    def get_serializer_class(self):
        booking_type = self.request.data.get('type')
       
        if booking_type == 'test':
            return AppAPIsTestBookModelListSerializer
        elif booking_type == 'doctor':
            return AppAPIsDoctorBookModelListSerializer
        elif booking_type == 'opd':
            return AppAPIsOPDSBookModelListSerializer
        
        else:
            # Handle the case when the booking type is not specified or invalid
            return None

    def get_queryset(self):
        authenticated_user = 23
        
        booking_type = self.request.GET.get('type')

        if booking_type == 'test':
            return TestBookingModel.objects.filter(user=authenticated_user)
        elif booking_type == 'doctor':
            return DoctorBookingModel.objects.filter(user=authenticated_user)
        elif booking_type == 'opd':
            return OPDBookingModel.objects.filter(user=authenticated_user)
        else:
            # Handle the case when the booking type is not specified or invalid
            return None

    def get(self, request, *args, **kwargs):
        serializer_class = self.get_serializer_class()
        if serializer_class is None:
            return Response({"message": "Invalid booking type"}, status=status.HTTP_400_BAD_REQUEST)

        queryset = self.get_queryset()
        if queryset is None:
            return Response({"message": "Invalid booking type"}, status=status.HTTP_400_BAD_REQUEST)

        serializer = serializer_class(queryset, many=True)
        return Response(serializer.data, status=status.HTTP_200_OK)

    def post(self, request, *args, **kwargs):
        authenticated_user = request.user
        booking_type = request.data.get('type')
        print(booking_type)
        
        booking_id = request.data.get('booking_id')  # Adjust the field name based on your actual model
        print(booking_id)
        try:
            if booking_type not in ['test', 'doctor','opd']:
                    return Response({"message": "Invalid booking type"}, status=status.HTTP_400_BAD_REQUEST)
            else:
                try:
                    if booking_type == 'test':
                        booking_instance = TestBookingModel.objects.get(id=booking_id, user=authenticated_user)
                        
                    elif booking_type == 'doctor':
                        booking_instance = DoctorBookingModel.objects.get(id=booking_id, user=authenticated_user)

                    elif booking_type == 'opd':
                        booking_instance = OPDBookingModel.objects.get(id=booking_id, user=authenticated_user)
                except (TestBookingModel.DoesNotExist, DoctorBookingModel.DoesNotExist):
                    return Response({"message": "Booking not found"}, status=status.HTTP_404_NOT_FOUND)
                
                booking_instance.is_booked = False  # Set is_booked to False
                booking_instance.save()

                serializer_class = self.get_serializer_class()
                serializer = serializer_class(booking_instance)
                data = {
                    'success': True,
                    'booking': "Successfully Cancelled Booking" 
                }
                
                return Response({"data":data} , status=status.HTTP_200_OK)

        except (TestBookingModel.DoesNotExist, DoctorBookingModel.DoesNotExist):
            return Response({"message": "Booking not found"}, status=status.HTTP_404_NOT_FOUND)

        except Exception as e:
            return Response({"message": f"Something went wrong: {e}"}, status=status.HTTP_500_INTERNAL_SERVER_ERROR)

from users.models import UserModel
from organisation.models import OrganisationModel,OrganisationsDoctorModel,TestModel
class AppAPIsDoctorBookingModelCreateAPIView(generics.GenericAPIView):
    serializer_class = AppAPIsDoctorBookModelSaveListSerializer
    
    def post(self, request, *args, **kwargs):
        authenticated_user = self.request.user
        print(request.data)
        mutable_data = request.data.copy()
       
        hospital_name = mutable_data.get('hospital_name')
        doctor = mutable_data.get('doctor')
        booking_details = mutable_data.get('booking_details')  # Assuming 'hospital_name' is the ID
        # Add the user ID and hospital_name ID to the mutable data
        mutable_data['user'] = authenticated_user.id
        mutable_data['is_booked'] = True
        mutable_data['hospital_name'] = hospital_name
        mutable_data['booking_details'] = booking_details
        serializer = self.get_serializer(data=mutable_data)
        serializer.is_valid(raise_exception=True)

        # Custom logic before saving, if needed
        self.perform_create(serializer)
        organisation = OrganisationModel.objects.get(id=hospital_name)
        doctordetails = OrganisationsDoctorModel.objects.get(id=doctor)
        
        
        # print(serializer.data)
        # Generate PDF receipt and save the path to the table
        pdf_path = self.generate_pdf_receipt(serializer.instance,serializer.data,organisation,doctordetails)
        
        # Update the serializer data with the PDF path
        serializer_data = {
            'pdf_receipt_path': pdf_path,
            **serializer.data,
        }

        response_data = {
            'success': True,
            **serializer_data,
        }

        return Response(response_data, status=status.HTTP_200_OK)

    def perform_create(self, serializer):
        serializer.save()

    def generate_pdf_receipt(self, instance,data,organisation,doctordetails):
        pdf_filename = f"{instance.user_id}_{instance.id}_receipt.pdf"
        target_directory = os.path.join(settings.MEDIA_ROOT, 'receipts')
        os.makedirs(target_directory, exist_ok=True)
        pdf_path_full = os.path.join(target_directory, pdf_filename).split("media/", 1)[-1]


        response = HttpResponse(content_type='application/pdf')
        response['Content-Disposition'] = f'attachment; filename="{pdf_filename}"'
        doc = SimpleDocTemplate(pdf_path_full, pagesize=letter)
        styles = getSampleStyleSheet()

        # Define custom styles
        sliced_style = styles['Italic'].clone('sliced')
        sliced_style.textColor = '#7EC8E3'
        sliced_style.fontSize = 20

        invoice_style = styles['Italic'].clone('invoice')
        invoice_style.textColor = '#000C66'
        invoice_style.fontSize = 20

        invoice1_style = styles['Normal'].clone('invoice1')
        invoice1_style.textColor = '#000'
        invoice1_style.fontSize = 20
        invoice1_style.fontName = 'Helvetica-Bold'
        invoice1_style.alignment = 2

        # bold_style = styles['Normal']
        # invoice1_style.textColor = '#000'
        # invoice1_style.fontSize = 10
        # invoice1_style.fontName = 'Helvetica-Bold'

        bold_style = styles['Normal']
        bold_style.textColor = '#000'
        bold_style.fontSize = 10
        bold_style.fontName = 'Helvetica-Bold'
        

        # Define a function to generate table styles
        def generate_table_style(data, header_bg='#C5C5C5', row_bg=colors.white):
            table_style = TableStyle([
                ('BACKGROUND', (0, 0), (-1, 0), header_bg),
                ('TEXTCOLOR', (0, 0), (-1, 0), colors.black),
                ('ALIGN', (0, 0), (-1, -1), 'RIGHT'),
                ('FONTNAME', (0, 0), (-1, 0), 'Helvetica-Bold'),
                ('MARGINTOP', (0, 0), (-1, 0), 12),
                ('BOTTOMPADDING', (0, 0), (-1, 0), 12),
                ('BACKGROUND', (0, 1), (-1, -1), row_bg),
                ('GRID', (0, 0), (-1, -1), 1, colors.black),
                ('RIGHTPADDING', (0, 0), (-1, -1), 40),
                # Add width adjustments here
                ('COLWIDTHS', (0, 0), (-1, -1), [100, 100, 100, 100]),  # Adjust width of each column as needed
            ])
            for row in range(len(data)):
                for col in range(len(data[row])):
                    if data[row][col] == '':
                        table_style.add('GRID', (col, row), (col, row), 0, colors.white)
                    else:
                        table_style.add('GRID', (col, row), (col, row), 1, '#C5C5C5')
            return table_style
           

        # Create table data
        table_data = [
            ['Order Number', '12345'],
        ]

        table_data1 = [
            ['Hospital Name','Address'],
            [organisation.title,organisation.address1],
        ]

        table_datak = [
            ['Booking Type', 'Doctor Name', 'Price'],
            ["Doctor", doctordetails.name, doctordetails.price],
        ]

        table_data2 = [
            [ 'Total','₹' ,doctordetails.price ],
            
        ]

        # Apply table styles
        table_style = generate_table_style(table_data)
        table1_style = generate_table_style(table_data1)
        table2_style = generate_table_style(table_data2)

        # Create tables
        table = Table(table_data, style=table_style)
        table1 = Table(table_data1, style=table1_style)
        table2 = Table(table_datak, style=table1_style)
        
        current_date = datetime.now().strftime("%Y-%m-%d")
        print(current_date)
        invoice_date_style = ParagraphStyle(
        name='InvoiceDate',
        parent=styles['Normal'],  # Assuming styles is a dictionary containing your existing styles
        textColor='#000',  # Black color
        fontSize=10,
        fontName='Helvetica',
         )
        # Define content
        content = [
            Spacer(1, 1),
            Paragraph('Invoice', invoice1_style),
            Spacer(1, 12),
            Paragraph('From:', styles['Normal']),
            Spacer(1, 5),
            Paragraph("Surjabasha", styles['Normal']),
            Spacer(19,10),
            # table,
            Spacer(1, 12),
            Paragraph('To:', styles['Normal']),
            Spacer(1, 5),
            Paragraph(data['mobile_number'], styles['Normal']),
            Spacer(1, 10),
            Spacer(1, 12),
            Paragraph('Hospital Details:', bold_style),
            Spacer(1,10),
            table1,
            Spacer(1, 20),
            table2,
            Spacer(1, 20),
            Paragraph('Invoice Date:', styles['Normal']),
            Spacer(1, 5),
            Paragraph(current_date, styles['Normal']),
            Spacer(1, 10),
            Paragraph('Thanks for choosing Surjabasha for Booking| surjabasha@gmail.com.com', styles['Normal']),
            Spacer(1, 10),
            Paragraph('This Reciept is Generated automatically ', styles['Normal']),
            Spacer(1, 1)
        ]

        # Build the PDF
        doc.build(content)

        # Update the instance with the PDF path
        instance.pdf = pdf_path_full
        instance.save()

        return pdf_path_full

class AppAPIsTestBookingModelCreateAPIView(generics.GenericAPIView):
    serializer_class = AppAPIsTestBooknewModelListSerializer

    def post(self, request, *args, **kwargs):
        authenticated_user = self.request.user
       
       
        # Create a mutable copy of the request data
        mutable_data = request.data.copy()
        print(request.data)
        hospital_name = mutable_data.get('hospital_name')
        test = mutable_data.get('test')
        booking_details = mutable_data.get('booking_details')  # Assuming 'hospital_name' is the ID
        # Add the user ID and hospital_name ID to the mutable data
        mutable_data['user_id'] = authenticated_user.id
        mutable_data['is_booked'] = True
        mutable_data['hospital_name'] = hospital_name
        mutable_data['booking_details'] = booking_details
        serializer = self.get_serializer(data=mutable_data)
        serializer.is_valid(raise_exception=True)

        # Custom logic before saving, if needed
        self.perform_create(serializer)
        organisation = OrganisationModel.objects.get(id=hospital_name)
        testdetails = TestModel.objects.get(id=test)

        # Generate PDF receipt and save the path to the table
        pdf_path = self.generate_pdf_receipt(serializer.instance,serializer.data,organisation,testdetails)

        # Update the serializer data with the PDF path
        serializer_data = {
            'pdf_receipt_path': pdf_path,
            **serializer.data,
        }

        response_data = {
            'success': True,
            **serializer_data,
        }

        return Response(response_data, status=status.HTTP_200_OK)

    def perform_create(self, serializer):
        serializer.save()

    def generate_pdf_receipt(self, instance,data,organisation,testdetails):
        pdf_filename = f"{instance.user_id}_{instance.id}_receipt.pdf"
        target_directory = os.path.join(settings.MEDIA_ROOT, 'receipts')
        os.makedirs(target_directory, exist_ok=True)
        pdf_path_full = os.path.join(target_directory, pdf_filename).split("media/", 1)[-1]

        response = HttpResponse(content_type='application/pdf')
        response['Content-Disposition'] = f'attachment; filename="{pdf_filename}"'

        doc = SimpleDocTemplate(pdf_path_full, pagesize=letter)
        styles = getSampleStyleSheet()

        sliced_style = styles['Italic'].clone('sliced')
        sliced_style.textColor = '#7EC8E3'
        sliced_style.fontSize = 20

        invoice_style = styles['Italic'].clone('invoice')
        invoice_style.textColor = '#000C66'
        invoice_style.fontSize = 20

        invoice1_style = styles['Normal'].clone('invoice1')
        invoice1_style.textColor = '#000'
        invoice1_style.fontSize = 20
        invoice1_style.fontName = 'Helvetica-Bold'
        invoice1_style.alignment = 2


        bold_style = styles['Normal']
        bold_style.textColor = '#000'
        bold_style.fontSize = 10
        bold_style.fontName = 'Helvetica-Bold'
        
        def generate_table_style(data):
            table_style = TableStyle([
                ('BACKGROUND', (0, 0), (-1, 0), '#C5C5C5'),
                ('TEXTCOLOR', (0, 0), (-1, 0), colors.black),
                ('ALIGN', (0, 0), (-1, -1), 'RIGHT'),
                ('FONTNAME', (0, 0), (-1, 0), 'Helvetica-Bold'),
                ('MARGINTOP', (0, 0), (-1, 0), 12),
                ('BOTTOMPADDING', (0, 0), (-1, 0), 12),
                ('BACKGROUND', (0, 1), (-1, -1), colors.white),
                ('GRID', (0, 0), (-1, -1), 1, colors.black),
                ('RIGHTPADDING', (0, 0), (-1, -1), 50),
                ('LEFTINDENT', (0, 0), (-1, -1), 300),
            ])
            for row in range(len(data)):
                for col in range(len(data[row])):
                    if data[row][col] == '':
                        table_style.add('GRID', (col, row), (col, row), 0, colors.white)
                    else:
                        table_style.add('GRID', (col, row), (col, row), 1, '#C5C5C5')

            return table_style

        table1_style = TableStyle([
            ('BACKGROUND', (0, 0), (-1, 0), '#C5C5C5'),
            ('TEXTCOLOR', (0, 0), (-1, 0), colors.black),
            ('ALIGN', (0, 0), (-1, -1), 'RIGHT'),
            ('FONTNAME', (0, 0), (-1, 0), 'Helvetica-Bold'),
            ('MARGINTOP', (0, 0), (-1, 0), 12),
            ('BOTTOMPADDING', (0, 0), (-1, 0), 12),
            ('BACKGROUND', (0, 1), (-1, -1), colors.white),
            ('GRID', (0, 0), (-1, -1), 1, colors.black),
            ('RIGHTPADDING', (0, 0), (-1, -1), 40),
            # ('LEFTINDENT', (0, 0), (-1, -1), 340),
        ])

        def generate_table_style(data):
            table_style = TableStyle([
                ('BACKGROUND', (0, 0), (-1, 0), '#FFFFFF'),
                ('TEXTCOLOR', (0, 0), (-1, 0), colors.black),
                ('ALIGN', (0, 0), (-1, -1), 'LEFT'),
                ('FONTNAME', (0, 0), (-1, 0), 'Helvetica-Bold'),
                ('MARGINTOP', (0, 0), (-1, 0), 12),
                ('BOTTOMPADDING', (0, 0), (-1, 0), 12),
                ('BACKGROUND', (0, 1), (-1, -1), colors.white),
                ('RIGHTPADDING', (0, 0), (-1, -1), 50),
            ])

            for row in range(len(data)):
                for col in range(len(data[row])):
                    if data[row][col] == '':
                        table_style.add('GRID', (col, row), (col, row), 0, colors.white)
                    else:
                        table_style.add('GRID', (col, row), (col, row), 1, '#C5C5C5')

            return table_style

        # Define your HTML content with applied styles
        # html_content_sliced = 'Sliced<font color="#000C66">Invoices</font>'
        html_content_invoice1 = 'Invoice'
        html_content_form = 'Form:'
        html_content_demo =organisation.title
        html_content_suit =  organisation.sub_title
        html_content_suit1 = organisation.address1
        # html_content_suit2 = 'Suite 5A-1204'
        # html_content_suit3 = 'admin@slicedinvoices.com'

        # Create a list of lists for your table data
        table_data = [
            # ['', '', '', '', '','Invoice Number', f'INV-{data['id']}'],
            ['', '', '', '', '','Order Number', '12345'],
           
            # ['', '', '', '', '','Due Date', ''],
            # ['', '', '', '', '','Total Due', ''],
        ]

        html_content_one = 'To:'
        html_content_two = data['patient_name']
        html_content_three =  data['address']
        html_content_four =  data['mobile_number']
        # html_content_five = 'test@test.com'

        table_data1 = [
            ['Hospital Name', 'Address', 'Type', 'Test Name', 'Price'],
            [organisation.title, organisation.address1, 'Test',testdetails.name, testdetails.price],
        ]

        table_datak = [
            [ 'Type', 'Test Name', 'Price'],
            [ 'Test',testdetails.name, testdetails.price],
        ]

        table_data2 = [
            ['', '', '', '', '', '','Total', testdetails.price],
            # ['', '', '', '', '','', 'Tax', '$8.50'],
            ['', '', '', '', '','', 'Total', testdetails.price],
        ]
        
        current_date = datetime.now().strftime("%Y-%m-%d")
        table_style = generate_table_style(table_data)
        table2 = Table(table_datak, style=table1_style)
        table1 = Table(table_data1, style=table1_style)
        table_style2 = generate_table_style(table_data2)
        # table2 = Table(table_data2, style=table_style2)
        # Create Paragraph objects with applied styles
        content = [
            # Paragraph(html_content_sliced, sliced_style),
              Spacer(1, 1),
            Paragraph('Invoice', invoice1_style),
            Spacer(1, 12),
            Paragraph('From:', styles['Normal']),
            Spacer(1, 5),
            Paragraph("Surjabasha", styles['Normal']),
            Spacer(19,10),
            # table,
            Spacer(1, 12),
            Paragraph('To:', styles['Normal']),
            Spacer(1, 5),
            Paragraph(data['mobile_number'], styles['Normal']),
            Spacer(1, 10),
            Spacer(1, 12),
            Paragraph('Hospital Details:', bold_style),
            Spacer(1,10),
            table1,
            Spacer(1, 20),
            table2,
            Spacer(1, 20),
            Paragraph('Invoice Date:', styles['Normal']),
            Spacer(1, 5),
            Paragraph(current_date, styles['Normal']),
            Spacer(1, 10),
            Paragraph('Thanks for choosing Surjabasha for Booking| surjabasha@gmail.com.com', styles['Normal']),
            Spacer(1, 10),
            Paragraph('This Reciept is Generated automatically ', styles['Normal']),
            Spacer(1, 1)
        ]

        # Build the PDF
        doc.build(content)

        # Update the instance with the PDF path
        instance.pdf = pdf_path_full
        instance.save()

        return pdf_path_full

# class AppAPIsOPDBookingModelCreateAPIView(generics.GenericAPIView):
#     serializer_class = AppAPIsOPDBookModelListSerializer

#     def post(self, request, *args, **kwargs):
#         authenticated_user = self.request.user

#         # Create a mutable copy of the request data
#         mutable_data = request.data.copy()

#         # Add the user ID to the mutable data
#         mutable_data['user_id'] = authenticated_user.id
#         mutable_data['is_booked'] = True
#         serializer = self.get_serializer(data=mutable_data)
#         serializer.is_valid(raise_exception=True)

#         # Custom logic before saving, if needed
#         self.perform_create(serializer)

#         # Generate PDF receipt and save the path to the table
#         pdf_path = self.generate_pdf_receipt(serializer.instance)

#         # Update the serializer data with the PDF path
#         serializer_data = {
#             'pdf_receipt_path': pdf_path,
#             **serializer.data,
#         }

#         response_data = {
#             'success': True,
#             **serializer_data,
#         }

#         return Response(response_data, status=status.HTTP_200_OK)

#     def perform_create(self, serializer):
#         serializer.save()

#     def generate_pdf_receipt(self, instance):
#         pdf_filename = f"{instance.user_id}_{instance.id}_receipt.pdf"
#         target_directory = os.path.join(settings.MEDIA_ROOT, 'receipts')
#         os.makedirs(target_directory, exist_ok=True)
#         pdf_path_full = os.path.join(target_directory, pdf_filename)

#         response = HttpResponse(content_type='application/pdf')
#         response['Content-Disposition'] = f'attachment; filename="{pdf_filename}"'

#         doc = SimpleDocTemplate(pdf_path_full, pagesize=letter)
#         styles = getSampleStyleSheet()

#         sliced_style = styles['Italic'].clone('sliced')
#         sliced_style.textColor = '#7EC8E3'
#         sliced_style.fontSize = 20

#         invoice_style = styles['Italic'].clone('invoice')
#         invoice_style.textColor = '#000C66'
#         invoice_style.fontSize = 20

#         invoice1_style = styles['Normal'].clone('invoice1')
#         invoice1_style.textColor = '#000'
#         invoice1_style.fontSize = 20
#         invoice1_style.fontName = 'Helvetica-Bold'
#         invoice1_style.alignment = 2

#         form_style = styles['Normal'].clone('form')
#         form_style.textColor = '#000'
#         form_style.fontSize = 10
#         form_style.fontName = 'Helvetica-Bold'
#         form_style.spaceBefore = 50

#         demo_style = styles['Normal'].clone('form')
#         demo_style.textColor = '#7EC8E3'
#         demo_style.fontSize = 10
#         demo_style.fontName = 'Helvetica-Bold'

#         suit_style = styles['Normal'].clone('form')
#         suit_style.textColor = '#000'
#         suit_style.fontSize = 10

#         suit1_style = styles['Normal'].clone('form')
#         suit1_style.textColor = '#000'
#         suit1_style.fontSize = 10
#         suit1_style.spaceBefore = 0

#         suit2_style = styles['Normal'].clone('form')
#         suit2_style.textColor = '#000'
#         suit2_style.fontSize = 10
#         suit2_style.spaceBefore = 0

#         suit3_style = styles['Normal'].clone('form')
#         suit3_style.textColor = '#000'
#         suit3_style.fontSize = 10
#         suit3_style.spaceBefore = 0

#         one_style = styles['Normal'].clone('form')
#         one_style.textColor = '#000'
#         one_style.fontSize = 10
#         one_style.spaceBefore = 0
#         one_style.fontName = 'Helvetica-Bold'

#         two_style = styles['Normal'].clone('form')
#         two_style.textColor = '#000'
#         two_style.fontSize = 10
#         two_style.spaceBefore = 0
        

#         three_style = styles['Normal'].clone('form')
#         three_style.textColor = '#000'
#         three_style.fontSize = 10
#         three_style.spaceBefore = 0

#         four_style = styles['Normal'].clone('form')
#         four_style.textColor = '#000'
#         four_style.fontSize = 10
#         four_style.spaceBefore = 0

#         five_style = styles['Normal'].clone('form')
#         five_style.textColor = '#000'
#         five_style.fontSize = 10
#         five_style.spaceBefore = 0

#         ANZ_style = styles['Normal'].clone('form')
#         ANZ_style.textColor = '#000'
#         ANZ_style.fontSize = 10
#         ANZ_style.spaceBefore = 0

#         ACC_style = styles['Normal'].clone('form')
#         ACC_style.textColor = '#000'
#         ACC_style.fontSize = 10
#         ACC_style.spaceBefore = 0

#         BSB_style = styles['Normal'].clone('form')
#         BSB_style.textColor = '#000'
#         BSB_style.fontSize = 10
#         BSB_style.spaceBefore = 0
        
#         choosing_style = styles['Normal'].clone('choosing')
#         choosing_style.textColor = '#000'
#         choosing_style.fontSize = 10
        
#         payment_style = styles['Normal'].clone('choosing')
#         payment_style.textColor = '#000'
#         payment_style.fontSize = 10
#         payment_style.spaceBefore = 2
#         payment_style.spaceAfter = 4

       
        
#         def generate_table_style(data):
#             table_style = TableStyle([
#                 ('BACKGROUND', (0, 0), (-1, 0), '#C5C5C5'),
#                 ('TEXTCOLOR', (0, 0), (-1, 0), colors.black),
#                 ('ALIGN', (0, 0), (-1, -1), 'RIGHT'),
#                 ('FONTNAME', (0, 0), (-1, 0), 'Helvetica-Bold'),
#                 ('MARGINTOP', (0, 0), (-1, 0), 12),
#                 ('BOTTOMPADDING', (0, 0), (-1, 0), 12),
#                 ('BACKGROUND', (0, 1), (-1, -1), colors.white),
#                 ('GRID', (0, 0), (-1, -1), 1, colors.black),
#                 ('RIGHTPADDING', (0, 0), (-1, -1), 50),
#                 ('LEFTINDENT', (0, 0), (-1, -1), 300),
#             ])
#             for row in range(len(data)):
#                 for col in range(len(data[row])):
#                     if data[row][col] == '':
#                         table_style.add('GRID', (col, row), (col, row), 0, colors.white)
#                     else:
#                         table_style.add('GRID', (col, row), (col, row), 1, '#C5C5C5')

#             return table_style

#         table1_style = TableStyle([
#             ('BACKGROUND', (0, 0), (-1, 0), '#C5C5C5'),
#             ('TEXTCOLOR', (0, 0), (-1, 0), colors.black),
#             ('ALIGN', (0, 0), (-1, -1), 'RIGHT'),
#             ('FONTNAME', (0, 0), (-1, 0), 'Helvetica-Bold'),
#             ('MARGINTOP', (0, 0), (-1, 0), 12),
#             ('BOTTOMPADDING', (0, 0), (-1, 0), 12),
#             ('BACKGROUND', (0, 1), (-1, -1), colors.white),
#             ('GRID', (0, 0), (-1, -1), 1, colors.black),
#             ('RIGHTPADDING', (0, 0), (-1, -1), 40),
#             # ('LEFTINDENT', (0, 0), (-1, -1), 340),
#         ])

#         def generate_table_style(data):
#             table_style = TableStyle([
#                 ('BACKGROUND', (0, 0), (-1, 0), '#FFFFFF'),
#                 ('TEXTCOLOR', (0, 0), (-1, 0), colors.black),
#                 ('ALIGN', (0, 0), (-1, -1), 'LEFT'),
#                 ('FONTNAME', (0, 0), (-1, 0), 'Helvetica-Bold'),
#                 ('MARGINTOP', (0, 0), (-1, 0), 12),
#                 ('BOTTOMPADDING', (0, 0), (-1, 0), 12),
#                 ('BACKGROUND', (0, 1), (-1, -1), colors.white),
#                 ('RIGHTPADDING', (0, 0), (-1, -1), 50),
#             ])

#             for row in range(len(data)):
#                 for col in range(len(data[row])):
#                     if data[row][col] == '':
#                         table_style.add('GRID', (col, row), (col, row), 0, colors.white)
#                     else:
#                         table_style.add('GRID', (col, row), (col, row), 1, '#C5C5C5')

#             return table_style

#         # Define your HTML content with applied styles
#         html_content_sliced = 'Sliced<font color="#000C66">Invoices</font>'
#         html_content_invoice1 = 'Invoice'
#         html_content_form = 'Form:'
#         html_content_demo = 'DEMO - Sliced Invoices'
#         html_content_suit = 'Suite 5A-1204'
#         html_content_suit1 = 'Your City AZ 12345'
#         html_content_suit2 = 'Suite 5A-1204'
#         html_content_suit3 = 'admin@slicedinvoices.com'

#         # Create a list of lists for your table data
#         table_data = [
#             ['', '', '', '', '','Invoice Number', 'INV-3337'],
#             ['', '', '', '', '','Order Number', '12345'],
#             ['', '', '', '', '','Invoice Date', 'january25,2016'],
#             ['', '', '', '', '','Due Date', 'january31,2016'],
#             ['', '', '', '', '','Total Due', '$93.05'],
#         ]

#         html_content_one = 'To:'
#         html_content_two = 'Test Business'
#         html_content_three = '123 Somewhere St'
#         html_content_four = 'Melbourne , VIC 3000'
#         html_content_five = 'test@test.com'

#         table_data1 = [
#             ['Hrs/Qty', 'Service', 'Rate/Price', 'Adjust', 'Sub Total'],
#             ['1.00', 'Web Design', '$85.00', '0.00%', '$85.00'],
#         ]

#         table_data2 = [
#             ['', '', '', '', '', '','Sub Total', '$85.00'],
#             ['', '', '', '', '','', 'Tax', '$8.50'],
#             ['', '', '', '', '','', 'Total Due', '$93.05'],
#         ]

#         html_content_ANZ = 'ANZ Bank'
#         html_content_ACC = 'ACC # 1234 1234'
#         html_content_BSB = 'BSB # 4321 432'

#         html_content_payment = 'Payment is due within 30 days from date of invoice. Late payment is subject to fees of 5% per month'
#         html_content_choosing = 'Thanks for choosing<font color="#7EC8E3">DEMO-Sliced Invoices| admin@slicedinvoices.com</font>'

#         table_style = generate_table_style(table_data)
#         table = Table(table_data, style=table_style)
#         table1 = Table(table_data1, style=table1_style)
#         table_style2 = generate_table_style(table_data2)
#         table2 = Table(table_data2, style=table_style2)
#         # Create Paragraph objects with applied styles
#         content = [
#             Paragraph(html_content_sliced, sliced_style),
#             Spacer(1, 1),
#             Paragraph(html_content_invoice1, invoice1_style),
#             Spacer(1, 12),
#             Paragraph(html_content_form, form_style),
#             Spacer(1, 1),
#             Paragraph(html_content_demo, demo_style),
#             Spacer(1, 1),
#             Paragraph(html_content_suit, suit_style),
#             Spacer(1, 1),
#             Paragraph(html_content_suit1, suit1_style),
#             Spacer(1, 1),
#             Paragraph(html_content_suit2, suit2_style),
#             Spacer(1, 1),
#             Paragraph(html_content_suit3, suit3_style),
#             Spacer(19, 30),
#             table,
#             Spacer(1, 12),
#             Paragraph(html_content_one, one_style),
#             Spacer(1, 1),
#             Paragraph(html_content_two, two_style),
#             Spacer(1, 1),
#             Paragraph(html_content_three, three_style),
#             Spacer(1, 1),
#             Paragraph(html_content_four, four_style),
#             Spacer(1, 1),
#             Paragraph(html_content_five, five_style),
#             Spacer(1, 30),
#             table1,
#             Spacer(1, 20),
#             table2,
#             Spacer(1, 1),
#             Paragraph(html_content_ANZ, ANZ_style),
#             Spacer(1, 1),
#             Paragraph(html_content_ACC, ACC_style),
#             Spacer(1, 1),
#             Paragraph(html_content_BSB, BSB_style),
#             Spacer(1, 20),
#             Paragraph(html_content_payment, payment_style),
#             Spacer(1, 1),
#             Paragraph(html_content_choosing, choosing_style),
#             Spacer(1, 1)
#         ]

#         # Build the PDF
#         doc.build(content)

#         # Update the instance with the PDF path
#         instance.pdf = pdf_path_full
#         instance.save()

#         return pdf_path_full
    
class AppAPIsOPDBookingModelCreateAPIView(generics.GenericAPIView):
    serializer_class = AppAPIsOPDBookModelDataListSerializer
    
    def post(self, request, *args, **kwargs):
        authenticated_user = self.request.user
        
        # Create a mutable copy of the request data
        mutable_data = request.data.copy()
        hospital_name = request.data.get('hospital_name')
        # Add the user ID to the mutable data
        mutable_data['user'] = authenticated_user.id
        mutable_data['is_booked'] = True
        mutable_data['hospital_name'] = hospital_name

        queryset =  OPDBookingModel.objects.filter(opd_dept_id = request.data.get('opd_dept'),date = request.data.get('date')).order_by('-token').values("token")
        mutable_data['token'] = queryset[0]['token'] + 1 if len(queryset)  else 1

        hospitaldata = OrganisationModel.objects.get(id=hospital_name)
        opddepdata = OPDDepartments.objects.get(id=mutable_data['opd_dept'])
        opddepdata.days = list(opddepdata.opddepartmentsdays_set.all())

        # for i in opddepdata.opddepartmentsdays_set.all():
        #     print(i)
        
        info = {
            'patient_name':mutable_data['patient_name'],
            'address':mutable_data['address'],
            'mobile_number':mutable_data['mobile_number'],
            'date':mutable_data['date'],
            'token':mutable_data['token'],
            'opd_dept':mutable_data['opd_dept'],
            'opddepdata':opddepdata,
            'hospital':hospitaldata,
        }
       
        pdf_data = self.generate_pdf(info)
       

       
        file_path = self.save_pdf_to_file(pdf_data)
        
        mutable_data['pdf'] = file_path

        # test_admin = TestAdminModel(pdf=file_path,organisation_id=request.data['organisation_id'] )
        # test_admin.save()

        serializer = self.get_serializer(data=mutable_data)
        serializer.is_valid(raise_exception=True)
        serializer.save()
        
        # self.perform_create(serializer)

        serializer_data = {
            # 'pdf_receipt_path': pdf_path,
            **serializer.data, 
        }

        response_data = {
            'success': True,
            **serializer_data,
        }

        return Response(response_data, status=status.HTTP_200_OK)
    
    def generate_pdf(self,info):
        print(info)
        template = 'test_records/new.html'
        # Render the template with context
        html = render_to_string(template,info)
        
        # Create a PDF file using the HTML content
        pdf_data = io.BytesIO()
        pisa.CreatePDF(html, dest=pdf_data)
        return pdf_data.getvalue()
    
    def save_pdf_to_file(self, pdf_data):
        # Generate PDF file path
        unique_filename = f"test_report_{uuid.uuid4().hex}.pdf"

        # Generate PDF file path
        target_directory = os.path.join(settings.MEDIA_ROOT, 'receipts')
        os.makedirs(target_directory, exist_ok=True)
        file_path = os.path.join(target_directory, unique_filename)

        # Save the PDF data to the file
        with open(file_path, 'wb') as f:
            f.write(pdf_data)

        # Return the path relative to the MEDIA_ROOT directory
        return os.path.relpath(file_path, settings.MEDIA_ROOT)

    def perform_create(self, serializer):
        serializer.save()

    # def generate_pdf_receipt(self, instance,data,organisation):
       
    #     pdf_filename = f"{instance.user_id}_{instance.id}_receipt.pdf"
    #     target_directory = os.path.join(settings.MEDIA_ROOT, 'receipts')
    #     os.makedirs(target_directory, exist_ok=True)
    #     pdf_path_full = os.path.join(target_directory, pdf_filename)

    #     response = HttpResponse(content_type='application/pdf')
    #     response['Content-Disposition'] = f'attachment; filename="{pdf_filename}"'

    #     doc = SimpleDocTemplate(pdf_path_full, pagesize=letter)
    #     styles = getSampleStyleSheet()

    #     sliced_style = styles['Italic'].clone('sliced')
    #     sliced_style.textColor = '#7EC8E3'
    #     sliced_style.fontSize = 20

    #     invoice_style = styles['Italic'].clone('invoice')
    #     invoice_style.textColor = '#000C66'
    #     invoice_style.fontSize = 20

    #     invoice1_style = styles['Normal'].clone('invoice1')
    #     invoice1_style.textColor = '#000'
    #     invoice1_style.fontSize = 20
    #     invoice1_style.fontName = 'Helvetica-Bold'
    #     invoice1_style.alignment = 2

    #     form_style = styles['Normal'].clone('form')
    #     form_style.textColor = '#000'
    #     form_style.fontSize = 10
    #     form_style.fontName = 'Helvetica-Bold'
    #     form_style.spaceBefore = 50

    #     demo_style = styles['Normal'].clone('form')
    #     demo_style.textColor = '#7EC8E3'
    #     demo_style.fontSize = 10
    #     demo_style.fontName = 'Helvetica-Bold'

    #     suit_style = styles['Normal'].clone('form')
    #     suit_style.textColor = '#000'
    #     suit_style.fontSize = 10

    #     suit1_style = styles['Normal'].clone('form')
    #     suit1_style.textColor = '#000'
    #     suit1_style.fontSize = 10
    #     suit1_style.spaceBefore = 0

    #     suit2_style = styles['Normal'].clone('form')
    #     suit2_style.textColor = '#000'
    #     suit2_style.fontSize = 10
    #     suit2_style.spaceBefore = 0

    #     suit3_style = styles['Normal'].clone('form')
    #     suit3_style.textColor = '#000'
    #     suit3_style.fontSize = 10
    #     suit3_style.spaceBefore = 0

    #     one_style = styles['Normal'].clone('form')
    #     one_style.textColor = '#000'
    #     one_style.fontSize = 10
    #     one_style.spaceBefore = 0
    #     one_style.fontName = 'Helvetica-Bold'

    #     two_style = styles['Normal'].clone('form')
    #     two_style.textColor = '#000'
    #     two_style.fontSize = 10
    #     two_style.spaceBefore = 0
        

    #     three_style = styles['Normal'].clone('form')
    #     three_style.textColor = '#000'
    #     three_style.fontSize = 10
    #     three_style.spaceBefore = 0

    #     four_style = styles['Normal'].clone('form')
    #     four_style.textColor = '#000'
    #     four_style.fontSize = 10
    #     four_style.spaceBefore = 0

    #     five_style = styles['Normal'].clone('form')
    #     five_style.textColor = '#000'
    #     five_style.fontSize = 10
    #     five_style.spaceBefore = 0

    #     ANZ_style = styles['Normal'].clone('form')
    #     ANZ_style.textColor = '#000'
    #     ANZ_style.fontSize = 10
    #     ANZ_style.spaceBefore = 0

    #     ACC_style = styles['Normal'].clone('form')
    #     ACC_style.textColor = '#000'
    #     ACC_style.fontSize = 10
    #     ACC_style.spaceBefore = 0

    #     BSB_style = styles['Normal'].clone('form')
    #     BSB_style.textColor = '#000'
    #     BSB_style.fontSize = 10
    #     BSB_style.spaceBefore = 0
        
    #     choosing_style = styles['Normal'].clone('choosing')
    #     choosing_style.textColor = '#000'
    #     choosing_style.fontSize = 10
        
    #     payment_style = styles['Normal'].clone('choosing')
    #     payment_style.textColor = '#000'
    #     payment_style.fontSize = 10
    #     payment_style.spaceBefore = 2
    #     payment_style.spaceAfter = 4

       
        
    #     def generate_table_style(data):
    #         table_style = TableStyle([
    #             ('BACKGROUND', (0, 0), (-1, 0), '#C5C5C5'),
    #             ('TEXTCOLOR', (0, 0), (-1, 0), colors.black),
    #             ('ALIGN', (0, 0), (-1, -1), 'RIGHT'),
    #             ('FONTNAME', (0, 0), (-1, 0), 'Helvetica-Bold'),
    #             ('MARGINTOP', (0, 0), (-1, 0), 12),
    #             ('BOTTOMPADDING', (0, 0), (-1, 0), 12),
    #             ('BACKGROUND', (0, 1), (-1, -1), colors.white),
    #             ('GRID', (0, 0), (-1, -1), 1, colors.black),
    #             ('RIGHTPADDING', (0, 0), (-1, -1), 50),
    #             ('LEFTINDENT', (0, 0), (-1, -1), 300),
    #         ])
    #         for row in range(len(data)):
    #             for col in range(len(data[row])):
    #                 if data[row][col] == '':
    #                     table_style.add('GRID', (col, row), (col, row), 0, colors.white)
    #                 else:
    #                     table_style.add('GRID', (col, row), (col, row), 1, '#C5C5C5')

    #         return table_style

    #     table1_style = TableStyle([
    #         ('BACKGROUND', (0, 0), (-1, 0), '#C5C5C5'),
    #         ('TEXTCOLOR', (0, 0), (-1, 0), colors.black),
    #         ('ALIGN', (0, 0), (-1, -1), 'RIGHT'),
    #         ('FONTNAME', (0, 0), (-1, 0), 'Helvetica-Bold'),
    #         ('MARGINTOP', (0, 0), (-1, 0), 12),
    #         ('BOTTOMPADDING', (0, 0), (-1, 0), 12),
    #         ('BACKGROUND', (0, 1), (-1, -1), colors.white),
    #         ('GRID', (0, 0), (-1, -1), 1, colors.black),
    #         ('RIGHTPADDING', (0, 0), (-1, -1), 40),
    #         # ('LEFTINDENT', (0, 0), (-1, -1), 340),
    #     ])

    #     def generate_table_style(data):
    #         table_style = TableStyle([
    #             ('BACKGROUND', (0, 0), (-1, 0), '#FFFFFF'),
    #             ('TEXTCOLOR', (0, 0), (-1, 0), colors.black),
    #             ('ALIGN', (0, 0), (-1, -1), 'LEFT'),
    #             ('FONTNAME', (0, 0), (-1, 0), 'Helvetica-Bold'),
    #             ('MARGINTOP', (0, 0), (-1, 0), 12),
    #             ('BOTTOMPADDING', (0, 0), (-1, 0), 12),
    #             ('BACKGROUND', (0, 1), (-1, -1), colors.white),
    #             ('RIGHTPADDING', (0, 0), (-1, -1), 50),
    #         ])

    #         for row in range(len(data)):
    #             for col in range(len(data[row])):
    #                 if data[row][col] == '':
    #                     table_style.add('GRID', (col, row), (col, row), 0, colors.white)
    #                 else:
    #                     table_style.add('GRID', (col, row), (col, row), 1, '#C5C5C5')

    #         return table_style

    #     # Define your HTML content with applied styles
    #     # html_content_sliced = 'Sliced<font color="#000C66">Invoices</font>'
    #     html_content_invoice1 = 'Invoice'
    #     html_content_form = 'Form:'
    #     html_content_demo = organisation.title
    #     html_content_suit = organisation.sub_title
    #     html_content_suit1 =organisation.address1
    #     # html_content_suit2 = 'Suite 5A-1204'
    #     # html_content_suit3 = 'admin@slicedinvoices.com'

    #     # Create a list of lists for your table data
    #     table_data = [
    #         # ['', '', '', '', '','Invoice Number', f'INV-{data['id']}'],
    #         ['', '', '', '', '','Order Number', '12345'],
           
    #         # ['', '', '', '', '','Due Date', ''],
    #         # ['', '', '', '', '','Total Due', ''],
    #     ]

    #     html_content_one = 'To:'
    #     html_content_two = data['patient_name']
    #     html_content_three =  data['address']
    #     html_content_four =  data['mobile_number']
    #     # html_content_five = 'test@test.com'

    #     table_data1 = [
    #         ['Hrs/Qty', 'Service', 'Rate/Price', 'Adjust', 'Sub Total'],
    #         ['1.00', 'Web Design', '$85.00', '0.00%', '$85.00'],
    #     ]

    #     table_data2 = [
    #         ['', '', '', '', '', '','Sub Total', '$85.00'],
    #         ['', '', '', '', '','', 'Tax', '$8.50'],
    #         ['', '', '', '', '','', 'Total Due', '$93.05'],
    #     ]

    #     html_content_ANZ = 'ANZ Bank'
    #     html_content_ACC = 'ACC # 1234 1234'
    #     html_content_BSB = 'BSB # 4321 432'

    #     html_content_payment = 'Payment is due within 30 days from date of invoice. Late payment is subject to fees of 5% per month'
    #     html_content_choosing = 'Thanks for choosing<font color="#7EC8E3">DEMO-Sliced Invoices| admin@slicedinvoices.com</font>'

    #     table_style = generate_table_style(table_data)
    #     table = Table(table_data, style=table_style)
    #     table1 = Table(table_data1, style=table1_style)
    #     table_style2 = generate_table_style(table_data2)
    #     table2 = Table(table_data2, style=table_style2)
    #     # Create Paragraph objects with applied styles
    #     content = [
    #         # Paragraph(html_content_sliced, sliced_style),
    #         Spacer(1, 1),
    #         Paragraph(html_content_invoice1, invoice1_style),
    #         Spacer(1, 12),
    #         Paragraph(html_content_form, form_style),
    #         Spacer(1, 1),
    #         Paragraph(html_content_demo, demo_style),
    #         Spacer(1, 1),
    #         Paragraph(html_content_suit, suit_style),
    #         Spacer(1, 1),
    #         Paragraph(html_content_suit1, suit1_style),
    #         Spacer(1, 1),
    #         # Paragraph(html_content_suit2, suit2_style),
    #         # Spacer(1, 1),
    #         # Paragraph(html_content_suit3, suit3_style),
    #         Spacer(19, 30),
    #         table,
    #         Spacer(1, 12),
    #         Paragraph(html_content_one, one_style),
    #         Spacer(1, 1),
    #         # Paragraph(html_content_two, two_style),
    #         Spacer(1, 1),
    #         Paragraph(html_content_three, three_style),
    #         Spacer(1, 1),
    #         Paragraph(html_content_four, four_style),
    #         Spacer(1, 1),
    #         # Paragraph(html_content_five, five_style),
    #         Spacer(1, 30),
    #         # table1,
    #         # Spacer(1, 20),
    #         # table2,
    #         Spacer(1, 1),
    #         Paragraph(html_content_ANZ, ANZ_style),
    #         Spacer(1, 1),
    #         Paragraph(html_content_ACC, ACC_style),
    #         Spacer(1, 1),
    #         Paragraph(html_content_BSB, BSB_style),
    #         Spacer(1, 20),
    #         Paragraph(html_content_payment, payment_style),
    #         Spacer(1, 1),
    #         Paragraph(html_content_choosing, choosing_style),
    #         Spacer(1, 1)
    #     ]

    #     # Build the PDF
    #     doc.build(content)

    #     # Update the instance with the PDF path
    #     instance.pdf = pdf_path_full
    #     instance.save()

    #     return pdf_path_full


# class AppAPIsOrderModelAppointmentListAPIView(generics.ListAPIView):
#     serializer_class= SlotModel.objects.all()
#     filter_backends=[DjangoFilterBackend,filters.OrderingFilter]
#     filterset_fields=['status']
#     ordering_fields=['booking_id']

#     def get_queryset(self):
#         user = get_user_model().objects.get(pk=self.request.user.pk)
#         return user.OrganisationSlotBookingModel_booking_user.filter(doctor__category__organisation__org_type="HOSPITAL")

#     def list(self, request,*args,**kwargs):
# 	    serializer = self.serializer_class(self.filter_queryset(self.get_queryset()), many=True, context={"request":request})
# 	    return Response(serializer.data, status=status.HTTP_200_OK)

        
class AppAPIsDiagnosisOrderModelCreateAPIView(generics.GenericAPIView):
    serializer_class=AppAPIsOrderModelCreateSerializer

    def post(self,request):
        try:
            user_cart=UserCartModel.objects.get(user=request.user)#user=request.user
            slots=user_cart.slot.all()
            order_instance=OrderModel.objects.create(booking_id=generate_order_id(),user=request.user)
            for slot in slots:
                order_instance.items.add(slot)
                slot.booking_id=generate_slot_id()
                slot.booking_user=request.user
                slot.status="UPCOMING"
                slot.is_booked=True
                slot.save()
            # order_instance.items.set(slots)
            order_instance.save()
            if order_instance.items.all().count()>0:
                user_cart.slot.set([])#setting the cart empty
                user_cart.save()
                return Response({"message":"Order created successfully"},status=status.HTTP_200_OK)
            else:
                return Response({"message":"Something went wrong"},status=status.HTTP_400_BAD_REQUEST)
        except Exception as e:
            return Response({"message" : f"something went wrong, {e}"}, status=status.HTTP_400_BAD_REQUEST)

class AppAPIsHospitalOrderModelCreateAPIView(generics.GenericAPIView):
    serializer_class=AppAPIsOrderModelCreateSerializer

    def post(self,request,slot_id):
        try:
            # slot_id=self.kwargs['slot_id']
            slot_instance=OrganisationSlotBookingModel.objects.get(id=slot_id)
            order_instance=OrderModel.objects.create(booking_id=generate_order_id(),user=request.user)
            order_instance.items.add(slot_instance)
            order_instance.save()
            if order_instance.items.all().count()>0:
                slot_instance.booking_id=generate_slot_id()
                slot_instance.booking_user=request.user
                slot_instance.status="UPCOMING"
                slot_instance.is_booked=True
                slot_instance.save()
                return Response({"message":"Order created successfully"},status=status.HTTP_200_OK)
            else:
                return Response({"message":"Something went wrong"},status=status.HTTP_400_BAD_REQUEST)
        except Exception as e:
            return Response({"message" : f"something went wrong, {e}"}, status=status.HTTP_400_BAD_REQUEST)
            
class update_slots(views.APIView):
    def post(self,request):
        try:
            doctors=OrganisationDoctorModel.objects.all()
            for doctor in doctors:
                OrganisationSlotBookingModel.objects.create(doctor=doctor,date="2023-08-03",start_datetime="2023-08-03T10:00",end_datetime="2023-08-03T10:30")
                OrganisationSlotBookingModel.objects.create(doctor=doctor,date="2023-08-03",start_datetime="2023-08-03T10:30",end_datetime="2023-08-03T11:00")
                OrganisationSlotBookingModel.objects.create(doctor=doctor,date="2023-08-03",start_datetime="2023-08-03T11:00",end_datetime="2023-08-03T11:30")
                OrganisationSlotBookingModel.objects.create(doctor=doctor,date="2023-08-03",start_datetime="2023-08-03T11:30",end_datetime="2023-08-03T12:00")
                OrganisationSlotBookingModel.objects.create(doctor=doctor,date="2023-08-03",start_datetime="2023-08-03T12:00",end_datetime="2023-08-03T12:30")
                OrganisationSlotBookingModel.objects.create(doctor=doctor,date="2023-08-03",start_datetime="2023-08-03T12:30",end_datetime="2023-08-03T13:00")
                OrganisationSlotBookingModel.objects.create(doctor=doctor,date="2023-08-03",start_datetime="2023-08-03T13:00",end_datetime="2023-08-03T14:00")
                OrganisationSlotBookingModel.objects.create(doctor=doctor,date="2023-08-03",start_datetime="2023-08-03T14:00",end_datetime="2023-08-03T15:00")
                OrganisationSlotBookingModel.objects.create(doctor=doctor,date="2023-08-03",start_datetime="2023-08-03T15:00",end_datetime="2023-08-03T16:00")
                OrganisationSlotBookingModel.objects.create(doctor=doctor,date="2023-08-03",start_datetime="2023-08-03T16:00",end_datetime="2023-08-03T17:00")
                OrganisationSlotBookingModel.objects.create(doctor=doctor,date="2023-08-03",start_datetime="2023-08-03T17:00",end_datetime="2023-08-03T17:30")
            # slots=OrganisationSlotBookingModel.objects.all()
            # for slot in slots:
            #     slot.is_booked=False
            #     #datetime.combine(datetime(2023, 7, 19), slot.start_datetime.time())
            #     # slot.start_datetime=datetime.combine(datetime(2023, 7, 19), slot.start_datetime.time())
            #     # slot.end_datetime=datetime.combine(datetime(2023, 7, 19), slot.end_datetime.time())
            #     slot.save()
            #     print(slot)
            return Response({"message":"success"},status=status.HTTP_200_OK)
        except Exception as e:
            return Response({"message" : f"something went wrong, {e}"}, status=status.HTTP_400_BAD_REQUEST)

# class AppAPIsOrderModelListAPIView(generics.ListAPIView):
#     serializer_class=AppAPIsOrderModelListSerializer
#     # filter_backends=[DjangoFilterBackend]
#     # filterset_fields=['items__status']

#     def get_queryset(self):
#         return OrderModel.objects.filter(user=user)

# class AppAPIsOrderModelTestListAPIView(generics.ListAPIView):
#     serializer_class=AppAPIsOrganisationSlotBookingModelOrderTestListSerializer
#     filter_backends=[DjangoFilterBackend,filters.OrderingFilter]
#     filterset_fields=['status']

#     def get_queryset(self):
#         user = get_user_model().objects.get(pk=self.request.user.pk)
#         return user.OrganisationSlotBookingModel_booking_user.filter(doctor__category__organisation__org_type="DIAGNOSIS")

#     def list(self, request,*args,**kwargs):
# 	    serializer = self.serializer_class(self.filter_queryset(self.get_queryset()), many=True)
# 	    return Response(serializer.data, status=status.HTTP_200_OK)


# class AppAPIsOrderModelAppointmentListAPIView(generics.ListAPIView):
#     serializer_class=AppAPIsOrganisationSlotBookingModelOrderAppointmentListSerializer
#     filter_backends=[DjangoFilterBackend,filters.OrderingFilter]
#     filterset_fields=['status']
#     ordering_fields=['booking_id']

#     def get_queryset(self):
#         user = get_user_model().objects.get(pk=self.request.user.pk)
#         return user.OrganisationSlotBookingModel_booking_user.filter(doctor__category__organisation__org_type="HOSPITAL")

#     def list(self, request,*args,**kwargs):
# 	    serializer = self.serializer_class(self.filter_queryset(self.get_queryset()), many=True, context={"request":request})
# 	    return Response(serializer.data, status=status.HTTP_200_OK)

class AppAPIsOrganisationSlotBookingModelCreateAPIView(generics.CreateAPIView):
    queryset=OrganisationSlotBookingModel.objects.all()
    serializer_class=AppAPIsOrganisationSlotBookingModelCreateSerializer

    def create(self, request):
        try:
            serializer  = self.serializer_class(data=request.data, context={"request" : request})
            if serializer.is_valid():
                serializer.save()
                return Response({"message" : "Created Successfully"}, status=status.HTTP_200_OK)
            else:
                return Response({"message" : serializer.errors}, status=status.HTTP_400_BAD_REQUEST) 
        except Exception as e:
            return Response({"message" : f"something went wrong, {e}"}, status=status.HTTP_400_BAD_REQUEST)

class AppAPIsOrganisationSlotBookingModellistAPIView(generics.ListAPIView):
    queryset=OrganisationSlotBookingModel.objects.all()
    serializer_class=AppAPIsOrganisationSlotBookingModelCreateSerializer

class AppAPIsOrganisationSlotBookingModelCancelGenericAPIView(generics.GenericAPIView):
    queryset=OrganisationSlotBookingModel.objects.all()
    serializer_class=AppAPIsOrganisationSlotBookingModelPUTSerializer
    permission_classes=[permissions.IsAuthenticated]

    def get(self, request, id):
        try:
            query = self.get_queryset().get(booking_id=id)
            serializer = self.serializer_class(query, many=False)
            return Response(serializer.data, status=status.HTTP_200_OK)
        except Exception as e:
            return Response({"message" : f"something went wrong, {e}"}, status=status.HTTP_400_BAD_REQUEST)
    
    def put(self, request, id):
        try:
            query = self.get_queryset().get(booking_id=id)
            data={
                "booking_id":None,
                "is_booked":False,
                "booking_user":None,
                "status":"PENDING"
            }
            serializer = self.serializer_class(data=data, instance=query,context={"request": request})
            if serializer.is_valid():
                order_instance=query.OrderModel_items.first()
                order_instance.items.remove(query)
                serializer.save()
                return Response({"message" : serializer.data}, status=status.HTTP_200_OK)
            else:
                return Response({"message" : serializer.errors}, status=status.HTTP_400_BAD_REQUEST)
        except Exception as e:
            return Response({"message" : f"Something went wrong, {e}"}, status=status.HTTP_400_BAD_REQUEST)